<!-- #include file="i_utils.asp" -->

<% check_security(1) %>

<% if request("TopicId") = "" then response.redirect "forums.asp" %>

<%

'::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
'::: generated by aspapp v1.1 --- page version - 11/30/01 1:56:49 AM
'::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

'-------------------------------- DECLARATION SECTION ----------------------------------------------

''' NOTE: global vars are declared in i_utils.asp library.
''' The i_utils.asp library also contains various subrountines for
''' formatting, user managment, general database access, error 
''' handling and tree form functions. 

''''''''' view_topic
dim TopicId
dim Subject
dim TopicMessage
dim view_topic_sql
''''''''' edit_reply
dim user_id
dim Message
dim icon
dim DateAdded
dim ReplyId
dim ForumId
dim edit_reply_sql

':::::::::::::::::::::::::::::::::::: GENERAL SUBROUTINES :::::::::::::::::::::::::::::::::::::::::::::::::::::::

sub request_view_topic
''' request expected input parameters for this form

	TopicId = request("TopicId")
	Subject = request("Subject")
	TopicMessage = request("TopicMessage")

end sub

sub request_edit_reply
''' request expected input parameters for this form

	user_id = request("user_id")
	Message = request("Message")
	icon = request("icon")
	DateAdded = request("DateAdded")
	ReplyId = request("ReplyId")
	TopicId = request("TopicId")
	ForumId = request("ForumId")

end sub

'::::::::::::::::::::::::::::::: REQUEST AND VALIDATION ::::::::::::::::::::::::::::::::::::::::::::

sub validate_edit_reply
''' request and validate parameters passed from this form

	user_id = trim(request("user_id"))
	Message = trim(request("Message"))
	icon = trim(request("icon"))
	DateAdded = trim(request("DateAdded"))
	if DateAdded <> "" AND (not isdate(DateAdded)) then
		error_list.add "47218date","Added must be a valid date (MM/DD/YY)."
		b_error = true
	end if
	ReplyId = trim(request("ReplyId"))
	TopicId = trim(request("TopicId"))
	ForumId = trim(request("ForumId"))

end sub

'::::::::::::::::::::::::::::::: DEFAULT FIELD VALUES ::::::::::::::::::::::::::::::::::::::::::::

sub get_defaults_view_topic
''' set default values for this form


end sub

sub get_defaults_edit_reply
''' set default values for this form

	icon = "icon_4.gif"
	DateAdded = "" & now() & ""
	ForumId = request("forumid")

end sub


'------------------------------- DATABASE SUBROUTINES ----------------------------------------------

sub db_select_view_topic
	sql = "SELECT " & _ 
	"Message As TopicMessage, " & _ 
	"Subject, " & _ 
	"TopicId FROM Disc_Topics" & _ 
	" WHERE " & _ 
	"TopicId = " & to_sql(TopicId,"number") & ""
	set rs = cn.Execute(sql)
	if rs.EOF then
		msg_list.add "select_data_view_topic", "The record was removed from the database."
	else
	on error resume next
		TopicId = rs("TopicId")
		Subject = rs("Subject")
		TopicMessage = rs("TopicMessage")
	on error goto 0
	end if
	rs.Close
end sub

sub db_select_edit_reply
	sql = "SELECT " & _ 
	"DateAdded, " & _ 
	"icon, " & _ 
	"Message, " & _ 
	"ReplyId, " & _ 
	"TopicId, " & _ 
	"user_id FROM Disc_Replies" & _ 
	" WHERE " & _ 
	"ReplyId = " & to_sql(ReplyId,"number") & ""
	set rs = cn.Execute(sql)
	if rs.EOF then
		msg_list.add "select_data_edit_reply", "The record was removed from the database."
	else
	on error resume next
		user_id = rs("user_id")
		Message = rs("Message")
		icon = rs("icon")
		DateAdded = rs("DateAdded")
		ReplyId = rs("ReplyId")
		TopicId = rs("TopicId")
		ForumId = rs("ForumId")
	on error goto 0
	end if
	rs.Close
end sub

sub db_insert_edit_reply
	sql = "INSERT INTO Disc_Replies" & _ 
	"(" & _ 
	"DateAdded," & _ 
	"Icon," & _ 
	"Message," & _ 
	"TopicId," & _ 
	"user_id" & _ 
	") VALUES (" & _ 
	"" & to_sql(DateAdded,"text") & "," & _ 
	"" & to_sql(Icon,"text") & "," & _ 
	"" & to_sql(Message,"text") & "," & _ 
	"" & to_sql(TopicId,"number") & "," & _ 
	"" & to_sql(user_id,"number") & ");"
	'response.write sql
	on error resume next
	cn.Execute(sql)
	if err.Number <> 0 then
		b_error = true
		error_list.add "db_insert_edit_reply" & err.Number ,"The database insert failed. " & err.Description
	else
		set rs = cn.Execute("SELECT @@IDENTITY")
		ReplyId = rs(0)
		rs.Close
		msg_list.add "db_insert_edit_reply","The database insert was successful."
	end if
	on error goto 0
end sub

sub db_update_edit_reply
	sql = "UPDATE Disc_Replies SET " & _ 
	"DateAdded = " & to_sql(DateAdded,"text") & ", " & _ 
	"icon = " & to_sql(icon,"text") & ", " & _ 
	"Message = " & to_sql(Message,"text") & ", " & _ 
	"TopicId = " & to_sql(TopicId,"number") & ", " & _ 
	"user_id = " & to_sql(user_id,"number") & " WHERE " & _ 
	"ReplyId = " & ReplyId & ";"
	'response.write sql
	on error resume next
	cn.Execute(sql)
	if err.Number <> 0 then
		b_error = true
		error_list.add "db_update_edit_reply" & err.Number ,"The database update failed." & err.Description
	else
		msg_list.add "db_update_edit_reply","The database update was successful."
	end if
	on error goto 0

end sub

sub db_delete_edit_reply
	sql = "DELETE FROM Disc_Replies WHERE ReplyId = " & to_sql(ReplyId,"number") & ""
	'response.write sql

	cn.Execute(sql)

end sub


'----------------------------------- MAIN -------------------------------------------------------------

''' request form keys
TopicId = request("TopicId")
ReplyId = request("ReplyId")

''' determine if search parameters are being passed
do_search = request("do_search")

'----------------------------------- ACTION CASE HANDLER --------------------------------------------
''' request action
action = lcase(request("action"))

''' action case handler
select case action


case "select_view_topic"
'  select the requested key record from database

if TopicId <> "" then
db_select_view_topic
else
b_error = true
error_list.add "edit_view_topic", "Specify record to select."
end if


case "insert_edit_reply"
'  insert form data into database

validate_edit_reply
if not b_error then
	db_insert_edit_reply
	''' increment reply count and update date last
	cn.Execute("UPDATE Disc_Topics SET Replies = Replies+1, DateLast = '" & now() & "' WHERE TopicId = " & TopicId)
	cn.Execute("UPDATE Disc_Forums SET Posts = Posts+1 WHERE ForumId = " & request("ForumId"))
	if not b_error then response.redirect "forums.asp?topicid=" & request("topicid") & "&forumid=" & request("ForumId")
end if

case "update_edit_reply"
'  use form data to update an existing database record

validate_edit_reply
if not b_error then
if ReplyId <> "" then
	db_update_edit_reply
	''' update date of last entry
	cn.Execute("UPDATE Disc_Topics SET DateLast = '" & now() & "' WHERE TopicId = " & TopicId & "")
	response.redirect "forums.asp?topicid=" & request("topicid") & "&forumid=" & request("forumid")
else
	b_error = true
	error_list.add "update_edit_reply", "Specify record to update."
end if
end if



case "delete_edit_reply"
'  delete the requested key database record

ReplyId = request("ReplyId")
if ReplyId <> "" then
	db_delete_edit_reply
	''' decrement reply count and update date last
	cn.Execute("UPDATE Disc_Topics SET Replies = Replies-1 WHERE TopicId = " & TopicId)
else
	b_error = true
	error_list.add "delete_edit_reply", "Specify record to delete."
end if


'::::::::::::::::::::::::::::::::::::::::::::::::::::::::
'  custom action handler(s)
''' select 'custom actions' to specify your case statements
'::::::::::::::::::::::::::::::::::::::::::::::::::::::::

end select

''' no action was requested, so handle the default case for each form

if TopicId <> "" then
	db_select_view_topic
else
	get_defaults_view_topic
end if

if ReplyId <> "" then
	db_select_edit_reply
else
	get_defaults_edit_reply
end if



%>

<!-- #include file=i_header.asp -->

<H4>
<A href="forums.asp?ForumId=<% =ForumId %>" class="H4"><% =Subject %></A> &gt; Reply To
</H4>

<%

display_errs
display_msg

%>

<!----------------------------------------- display -------------------------------------------->

<!----------------------------- view_topic ----------------------------------->


<TABLE >
<FORM action="forums.asp" method=GET name="view_topic" >
	<input type=hidden name="TopicId" value="<% =TopicId %>">
<TR class=formtr valign=top>
	<TD class=labelTD align=right>Subject</TD>
	<TD class=dataTD width="80%">
			<a href="forums.asp?TopicId=<% =TopicId %>" class=dataFont><% =Subject%></a>
	</TD>
</TR>
<TR class=formtr valign=top>
	<TD class=labelTD align=right>Original Message</TD>
	<TD class=dataTD width="75%">
			<% =TopicMessage%>
	</TD>
</TR>
</FORM>
</TABLE>

<!----------------------------- edit_reply ----------------------------------->


<TABLE class=HeaderTable>
<TR>
	<TD class=HeaderTD><span class=HeaderFont>Compose Reply</span></TD>
</TR>
</TABLE>
<TABLE >
<FORM action="edit_reply.asp" method=POST name="edit_reply" >
<TR class='formTR'>
	<TD class=labelTD align=right>
	Message
	</TD>
	<TD class=dataTD width="75%">
	
	<textarea onKeyDown="" name="Message" rows=10 cols=80 wrap='off'><% =to_html(Message) %></textarea>
	
	</TD>
</TR>
<TR class='formTR'>
	<TD class=labelTD align=right>
	Icon
	</TD>
	<TD class=dataTD >
		<% if isNull(icon) then icon = "" %>
	<input type=radio <% if "icon_1.gif" = cStr(icon) then %>checked<% end if %> name="icon" value="icon_1.gif"><img src=images/icon_1.gif> 
	<input type=radio <% if "icon_2.gif" = cStr(icon) then %>checked<% end if %> name="icon" value="icon_2.gif"><img src=images/icon_2.gif> 
	<input type=radio <% if "icon_3.gif" = cStr(icon) then %>checked<% end if %> name="icon" value="icon_3.gif"><img src=images/icon_3.gif> 
	<input type=radio <% if "icon_4.gif" = cStr(icon) then %>checked<% end if %> name="icon" value="icon_4.gif"><img src=images/icon_4.gif> 
	<input type=radio <% if "icon_5.gif" = cStr(icon) then %>checked<% end if %> name="icon" value="icon_5.gif"><img src=images/icon_5.gif> 
	<input type=radio <% if "icon_6.gif" = cStr(icon) then %>checked<% end if %> name="icon" value="icon_6.gif"><img src=images/icon_6.gif> 
	<input type=radio <% if "icon_7.gif" = cStr(icon) then %>checked<% end if %> name="icon" value="icon_7.gif"><img src=images/icon_7.gif> 
	<input type=radio <% if "icon_8.gif" = cStr(icon) then %>checked<% end if %> name="icon" value="icon_8.gif"><img src=images/icon_8.gif> 
	<input type=radio <% if "icon_9.gif" = cStr(icon) then %>checked<% end if %> name="icon" value="icon_9.gif"><img src=images/icon_9.gif> 
	<input type=radio <% if "icon_10.gif" = cStr(icon) then %>checked<% end if %> name="icon" value="icon_10.gif"><img src=images/icon_10.gif> 
	</TD>
</TR>
<TR class=formtr>
	<TD class=labelTD align=right>&nbsp;
	<% if ReplyId <> "" then %><% end if %>
	</TD>
	<TD class=dataTD>
	<% if ReplyId = "" then %><input type=submit name=insert_button value="POST" onclick="document.edit_reply.action.value = 'insert_edit_reply'"><% end if %>
	<% if ReplyId <> "" then %><input type=submit name=update_button value="SAVE REPLY"><% end if %>
	<% if ReplyId <> "" then %><input type=submit name=delete_button value="DELETE" onclick="document.edit_reply.action.value = 'delete_edit_reply'"><% end if %>
	</TD>
</TR>
<input type=hidden name="action" value="<% if ReplyId <> "" then %>update<% else %>insert<%end if %>_edit_reply">
<input type=hidden name="user_id" value="<% =user_id %>"><input type=hidden name="DateAdded" value="<% =DateAdded %>"><input type=hidden name="ReplyId" value="<% =ReplyId %>"><input type=hidden name="TopicId" value="<% =TopicId %>"><input type=hidden name="ForumId" value="<% =ForumId %>">
</FORM>
</TABLE>

<!---------------------------------------- end display ------------------------------------------->




<%
''' assure that any db resources are freed
on error resume next
rs.Close
set rs = NOTHING
cn.Close
set cn = NOTHING
user_cn.Close
set user_cn = NOTHING
on error goto 0
%>
<!-- #include file=i_footer.asp -->


